﻿using Newtonsoft.Json;
using RealName.Factory.request.indivIdentity;
using RealName.Factory.response.indivIdentity;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using WindowsFormsApp1.Core;
using WindowsFormsApp1.Factory.request;

namespace RealName.Factory.indivIdentity
{
    /*
     * 获取个人实名认证地址
     */
    class IndivIdentityUrl : EsignRequest<IndivIdentityUrlResponse>
    {
        [JsonIgnore]
        public string accountId;
        public string authType;
        public AvailableAuthTypes availableAuthTypes;
        public string receiveUrlMobileNo;
        public ContextInfo contextInfo;
        public IndivInfo indivInfo;
        public PsnConfigParams configParams;
        public bool repeatIdentity = true;

        public IndivIdentityUrl(string accountId)
        {
            this.accountId = accountId;
        }
        public IndivIdentityUrl build() {
            base.Url = "/v2/identity/auth/web/" + accountId + "/indivIdentityUrl";
            base.ReqType = HttpType.POST;
            return this;
        }
    }
}
