﻿using Config;
using Newtonsoft.Json.Linq;
using RealName.Factory.comm;
using RealName.Factory.indivIdentity;
using RealName.Factory.infoverify;
using RealName.Factory.ocr;
using RealName.Factory.request.indivIdentity;
using RealName.Factory.response.comm;
using RealName.Factory.response.indivIdentity;
using RealName.Factory.response.infoverify;
using RealName.Factory.response.ocr;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using WindowsFormsApp1.Core;
using WindowsFormsApp1.Factory.account;
using WindowsFormsApp1.Factory.response.account;
using WinTechWrapperDemo.demoUtils;

namespace RealName
{
    public partial class FormMain : Form
    {
        public FormMain()
        {
            InitializeComponent();

        }

        private void button1_Click_1(object sender, EventArgs e)
        {

            //信息比对

            //弹出输入框，让用户填写姓名和身份证

            Individual individual = new Individual();
            if (individual.ShowDialog() == DialogResult.OK)
            {
                String name = individual.TextBoxValue;
                String idNo = individual.TextBoxValue2;
                individual.Close();

                IndividualBase indivBase=new IndividualBase(idNo,name);
                indivBase.build();
                string reqData = JSONHelper.EntityToJSON(indivBase);
                textBox1.Text = reqData;
                IndividualBaseResponse result = indivBase.Execute();
                textBox2.Text = result.body;

            }

        }

        private void button2_Click(object sender, EventArgs e)
        {
            //驾驶证OCR

            //选择驾驶证
            OpenFileDialog dialog = new OpenFileDialog();
            dialog.Multiselect = false;//该值确定是否可以选择多个文件
            dialog.Title = "请选择文件夹";
            dialog.Filter = "图像文件(*.jpg;*.png)|*.jpg;*.png";
            if (dialog.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                //选择的文件路径

                string file = dialog.FileName;
                //把图片转成Base64
                String data = GetFileInfo.ImageToBase64(file);

                DrivingLicence drivingLicence=new DrivingLicence(data);
                string reqData = JSONHelper.EntityToJSON(drivingLicence);
                textBox1.Text = reqData;
                DrivingLicenceResponse result=drivingLicence.build().Execute();
                textBox2.Text = result.body;
            }
        }

        private void button3_Click(object sender, EventArgs e)
        {
            //创建个人账户
            //弹出输入框，让用户填写姓名和身份证，手机和邮箱

            Account account = new Account();
            if (account.ShowDialog() == DialogResult.OK)
            {
                String name = account.TextBoxValue;
                String idNumber = account.TextBoxValue2;
                String mobile = account.TextBoxValue3;
                String email = account.TextBoxValue4;
                account.Close();

                string thirdPartyUserId = "1231232121312313213";
                CreatePersonByThirdPartyUserId createPerId = new CreatePersonByThirdPartyUserId(thirdPartyUserId, name, ParameterConfig.idType, idNumber);
                createPerId.mobile = mobile;
                createPerId.email = email;
                createPerId.build();
                //创建个人账户
                string reqData = JSONHelper.EntityToJSON(createPerId);
                textBox1.Text = reqData;
                CreatePersonByThirdPartyUserIdResponse result = createPerId.Execute();
                textBox2.Text = result.body;

                Console.WriteLine("账号" + result.data.accountId);
                Console.WriteLine("状态码" + result.status);
                Console.WriteLine("错误码" + result.code);
                Console.WriteLine("错误信息" + result.message);
                ParameterConfig.accountId = result.data.accountId;
            }
        }

        private void button4_Click(object sender, EventArgs e)
        {
            //个人网页版实名接口
            IndivIdentityUrl indivUrl=new IndivIdentityUrl(ParameterConfig.accountId);
            indivUrl.repeatIdentity = true;

            ContextInfo contextInfo=new ContextInfo();
            contextInfo.notifyUrl = ParameterConfig.notifyUrl;
            contextInfo.origin = ParameterConfig.origin;
            contextInfo.redirectUrl = ParameterConfig.redirectUrl;
            contextInfo.showResultPage = ParameterConfig.showResultPage;
            indivUrl.contextInfo = contextInfo;

            string reqData = JSONHelper.EntityToJSON(indivUrl);
            textBox1.Text = reqData;
            IndivIdentityUrlResponse result=indivUrl.build().Execute();
            textBox2.Text = result.body;
            ParameterConfig.flowId=result.data.flowId;
        }

        private void button5_Click(object sender, EventArgs e)
        {
            //查询认证信息
            QryIdentityOutline qryIdentityOutline = new QryIdentityOutline(ParameterConfig.flowId);
            string reqData = JSONHelper.EntityToJSON(qryIdentityOutline);
            textBox1.Text = reqData;
            QryIdentityOutlineResponse result = qryIdentityOutline.build().Execute();
            textBox2.Text = result.body;
        }
    }
}
    
